<?php

function CheckAdminLogin($x_User, $x_Password)
{
    $db = Oxid_GetDb();
    $rs = Sql_Execute($db, "SELECT oxpassword, UNHEX(oxpasssalt) AS oxpasssalt, oxpasssalt AS oxpasssalt_bin FROM oxuser WHERE oxusername = ? AND oxrights='malladmin'",array($x_User));
    if(!$rs->EOF)
    {
        if(strlen($rs->fields["oxpassword"]) == 32 && md5($x_Password . $rs->fields["oxpasssalt"]) == $rs->fields["oxpassword"])
            return true;
        if(strlen($rs->fields["oxpassword"]) == 128 && hash("sha512", $x_Password . $rs->fields["oxpasssalt_bin"]) == $rs->fields["oxpassword"])
            return true;
    }
    
    return false;
}

function SendScriptVersion() {
    global $sVersionNr, $sVersionDatum, $sAction, $config;

    $xml["STATUS"] = array(
        "STATUS_DATA" => array (
            "ACTION" => $sAction,
            "CODE" => '111',
            "SCRIPT_VER" => $sVersionNr,
            "SCRIPT_DATE" => $sVersionDatum,
            )
        );
    
    $xml["STATUS"]["LANGUAGES"] = array();

    $aLanguages = $config->getConfigParam('aLanguageParams');
    foreach($aLanguages as $sLangCode => $aLangData)
    {
        $xml["STATUS"]["LANGUAGES"][] = array(
            "LANG" => array(
                "CODE" => strtoupper($sLangCode),
                "ID" => $aLangData["baseId"]
                )
        );
    }

    print_xml($xml);
}

//--------------------------------------------------------------

function print_xml($x_Xml, $x_PrintHeader = true, $iLevel = 0)
{
    global $config;
    
    if($x_PrintHeader)
        echo '<?xml version="1.0" encoding="utf-8"?>' . "\n";
    
    foreach($x_Xml as $key => $value)
    {   
        //XML-Tags, die den gleichen Name verwenden z.B. <Values><Value>V1</Value><Value>V2</Value></Values>
        //müssen mit einem array dargestellt werden, der key ist dann der Index und kein Tag-Name
        $bNamedXmlTag = is_string($key);
        $bHasMultibleChilds = is_array($value);
        
        if($bNamedXmlTag)
        {
            //XML formatieren Levels mit Tab ausgeben
            echo str_repeat("\t",$iLevel);
        
            echo "<$key>";
            //Neue Zeile bei einem Array mit mehreren Unterelementen
            if($bHasMultibleChilds)
                echo "\n";
        }
        
        if($bHasMultibleChilds)
        {
            //Rekursiver aufruf der Funktion            
            print_xml($value, false, $bNamedXmlTag ? $iLevel + 1 : $iLevel);
        }
        else
        {
            echo htmlspecialchars($value);
        }
        
        if($bNamedXmlTag)
        {
            //End-Tag formatieren: Levels mit Tab ausgeben, wenn mehrere Childs
            // -> Sonst steht das End-Tag hinter dem Value
            if($bHasMultibleChilds)
                echo str_repeat("\t",$iLevel);
            
            $iEnd = strpos($key, " ");
            if($iEnd == false)
                $iEnd = strlen($key);
            echo "</" . substr($key,0,$iEnd) . ">\n";
        }
    }
}

function print_xml_status($x_Code, $x_Action, $x_Msg, $x_Mode = "", $x_Item = "", $x_Value = "", $x_ProductsCount = "", $x_CategoriesCount = "") {
    
    $xml["STATUS"] = array(
        "STATUS_DATA" => array(
            "CODE" => $x_Code,
            "ACTION" => $x_Action,
            "MESSAGE" => $x_Msg
            )
        );

    if (strlen($x_Mode) > 0)
        $xml["STATUS"]["STATUS_DATA"]["MODE"] = $x_Mode;

    if (strlen($x_Item) > 0)
        $xml["STATUS"]["STATUS_DATA"][$x_Item] = $x_Value;
    
    if(strlen($x_ProductsCount) > 0)
        $xml["STATUS"]["STATUS_DATA"]["PRODUCTS_TOTAL_COUNT"] = $x_ProductsCount;

    if(strlen($x_CategoriesCount) > 0)
        $xml["STATUS"]["STATUS_DATA"]["CATEGORIES_TOTAL_COUNT"] = $x_CategoriesCount;

    print_xml($xml);
}

function column_exists($x_Table, $x_Column) {
    $db = Oxid_GetDb();
    $rs = Sql_Execute($db, "SHOW COLUMNS FROM " . $x_Table . " LIKE '" . $x_Column . "'");
    return $rs->RecordCount() > 0;
}

// Hinzugefügt am 04.05.2012 von CM: Abfragen der Anzahl zum blockweisen Übertragen der Kategorien
function SendCategoriesCount(){
    global $DefaultShopId;
    
    $db = Oxid_GetDb();
    
    $count = Sql_GetOne($db, "SELECT COUNT(*) FROM oxcategories WHERE oxshopid = ? AND oxid LIKE 'AS_%'",array($DefaultShopId));
    if($count == null)
        $count = 0;

    print_xml_status(0,$_POST["action"], "", "", "", "", "", $count);
}

function SendCategories() {
    global $config, $DefaultShopId;
    
    $aLanguages = $config->getConfigParam('aLanguageParams');
    $aLanguageNames = $config->getConfigParam('aLanguages');
    $db = Oxid_GetDb();

    $sql = "SELECT oxid, oxparentid, oxthumb, oxsort ";

    foreach($aLanguages as $sLangCode => $aLangData)
    {
        $columNameAppendix = "";
        if($aLangData["baseId"] > 0)
            $columNameAppendix = "_" . $aLangData["baseId"];
        
        $sql .= ", oxtitle".$columNameAppendix;
    }
    
    $sql .= " FROM oxcategories WHERE oxshopid = ? AND oxid LIKE 'AS_%'";
    $sqlParams = array($DefaultShopId);
    
    $from = $_GET['from'];
    $count = $_GET['count'];
    
    if (!empty($from)) {
        if (empty($count))
            $count = 1000;
        $sql .= " LIMIT ?,?";
        $sqlParams[] = $from;
        $sqlParams[] = $count;
    }
    
    $rs = Sql_Execute($db, $sql, $sqlParams);

    echo "<?xml version='1.0' encoding='utf-8'?>\n"
    ."<CATEGORIES>\n";
        
    while(!$rs->EOF)
    {        
        $parentId = $rs->fields["oxparentid"];
        $parentId = $parentId == "oxrootid" ? "0" : str_replace("AS_" . $DefaultShopId . "_", "", $parentId);
        
        $xml["CATEGORIES_DATA"] = array(
            "ID" => str_replace("AS_" . $DefaultShopId . "_", "", $rs->fields["oxid"]),
            "PARENT_ID" => $parentId,
            "IMAGE_URL" => $rs->fields["oxthumb"],
            "SORT_ORDER" => $rs->fields["oxsort"],
            "DATE_ADDED" => "",
            "LAST_MODIFIED" => "",
            $sCatDesc
            );
                
        $sCatDesc = array();
        foreach($aLanguages as $sLangCode => $aLangData)
        {
            $iLangId = $aLangData["baseId"];
            $columNameAppendix = "";
            if($iLangId > 0)
                $columNameAppendix = "_" . $iLangId;

            $xml["CATEGORIES_DATA"][] = array(
                "CATEGORIES_DESCRIPTION ID='" . $iLangId . "' CODE='" . strtolower($sLangCode) . "' NAME='" . $aLanguageNames[$sLangCode] . "'" => array(
                    "NAME" => $rs->fields["oxtitle".$columNameAppendix],
                    "HEADING_TITLE" => $rs->fields["oxtitle".$columNameAppendix],
                    "DESCRIPTION" => $rs->fields["oxlongdesc".$columNameAppendix],
                    "META_TITLE" => "",
                    "META_DESCRIPTION" => "",
                    "META_KEYWORDS" => ""
                )
            );
        }

        // Geändert am 18.05.2012 von CM: Nur ausgeben, wenn wirklich benötigt
        if($_GET['skip_product_assignments'] != 'true')
        {
            $sql = "SELECT oxarticles.oxid, oxartnum FROM oxobject2category, oxarticles WHERE oxobject2category.oxcatnid = ? AND oxobject2category.oxobjectid = oxarticles.oxid";            
            $rsProducts = Sql_Execute($db, $sql, array($rs->fields["oxid"]));

            while(!$rsProducts->EOF)
            {
                $xml["CATEGORIES_DATA"][] = array(
                    "PRODUCTS ID='" . $rsProducts->fields["oxid"] . "' MODEL='" . $rsProducts->fields["oxartnum"] . "'" => "",
                    );
                    
                $rsProducts->MoveNext();
            }
        }
        
        print_xml($xml, false, 1);
        
        $rs->MoveNext();
    }
    $schema = '</CATEGORIES>' . "\n";
    echo $schema;
}

function SendOrders() {
    global $action, $DefaultShopId;
       
    $iOrderFrom = $_GET['order_from'];
    if(empty($iOrderFrom))
        $iOrderFrom = 0;
    
    //Oxid definiert als Constante den Key zum entschlüsseln der UserPayment-Daten in der oxUserPayment-Klasse
    $tmpUserPayment = new oxUserPayment();
    $sUserPaymentEncKey = $tmpUserPayment->getPaymentKey();
    unset($tmpUserPayment);
    
    $db = Oxid_GetDb();

    $sSql = "SELECT oxorder.oxid, oxorder.oxuserid, oxordernr, oxorderdate, oxcurrency, oxpaymenttype, oxdeltype, oxpaymentid, oxtotalbrutsum, oxtotalordersum, oxdelcost, oxdelvat, oxdiscount, oxremark, oxvoucherdiscount, oxbillustid, oxfolder "
        . ",oxbillcompany, oxbillfname, oxbilllname, oxbillstreet, oxbillstreetnr, oxbillzip, oxbillcity, oxbillcountry.oxisoalpha2 AS oxbillcountry, oxbillfon, oxbillemail, oxbillsal, oxbillfax "
        . ",oxdelcompany, oxdelfname, oxdellname, oxdelstreet, oxdelstreetnr, oxdelzip, oxdelcity, oxdelcountry.oxisoalpha2 as oxdelcountry, oxdelfon, oxdelsal, oxdelfax "
        . ",oxcustnr, oxbirthdate, oxtransid "
        . ",DECODE(oxuserpayments.oxvalue, ?) as oxpaymentdata "
        . "FROM oxorder "
        . "LEFT JOIN oxuser ON (oxorder.oxuserid = oxuser.oxid) "
        . "LEFT JOIN oxcountry AS oxbillcountry ON (oxorder.oxbillcountryid = oxbillcountry.oxid) "
        . "LEFT JOIN oxcountry AS oxdelcountry ON (oxorder.oxdelcountryid = oxdelcountry.oxid) "
        . "LEFT JOIN oxuserpayments ON (oxorder.oxpaymentid = oxuserpayments.oxid) "
        . "WHERE oxordernr >= ? AND oxorder.oxshopid = ? ORDER BY oxordernr ";

    echo "<?xml version='1.0' encoding='utf-8'?>\n" .
        "<Data>\n" .
        "\t<Header></Header>\n" .
        "\t<Orders>\n";
    
    $rsOrder = Sql_Execute($db, $sSql, array($sUserPaymentEncKey, $iOrderFrom, $DefaultShopId));
    while(!$rsOrder->EOF) {

        $sBillingSalutation = "";
        if(!empty($rsOrder->fields["oxbillsal"]))
            $sBillingSalutation = $rsOrder->fields["oxbillsal"] == "MRS" ? "Frau" : "Herr";

        $sShippingSalutation = "";
        if(!empty($rsOrder->fields["oxdelsal"]))
            $sShippingSalutation = $rsOrder->fields["oxdelsal"] == "MRS" ? "Frau" : "Herr";

        $xml["Order"] = array(
            "OrderNr" => $rsOrder->fields["oxordernr"], 
            "OrderTime" => $rsOrder->fields["oxorderdate"], 
            "OrderCurrency" => $rsOrder->fields["oxcurrency"], 
            "CustomerNr" => $rsOrder->fields["oxcustnr"], 
            "Status" => $rsOrder->fields["oxfolder"], 
            "VatID" => $rsOrder->fields["oxbillustid"],
            "Email" => $rsOrder->fields["oxbillemail"],
            "Comment" => $rsOrder->fields["oxremark"], 
            "BillingAddress" => array(
                "Company" => $rsOrder->fields["oxbillcompany"],
                "Salutation" => $sBillingSalutation,
                "Firstname" => $rsOrder->fields["oxbillfname"],
                "Lastname" => $rsOrder->fields["oxbilllname"],
                "Street" => $rsOrder->fields["oxbillstreet"],
                "StreetNr" => $rsOrder->fields["oxbillstreetnr"],
                "Zip" => $rsOrder->fields["oxbillzip"],
                "City" => $rsOrder->fields["oxbillcity"],
                "Country" => $rsOrder->fields["oxbillcountry"],
                "Phone" => $rsOrder->fields["oxbillfon"],
                "Fax" => $rsOrder->fields["oxbillfax"],
                "Email" => $rsOrder->fields["oxbillemail"]
                ),
            "ShippingAddress" => array(
                "Company" => $rsOrder->fields["oxdelcompany"],
                "Firstname" => $rsOrder->fields["oxdelfname"],
                "Lastname" => $rsOrder->fields["oxdellname"],
                "Street" => $rsOrder->fields["oxdelstreet"],
                "StreetNr" => $rsOrder->fields["oxdelstreetnr"],
                "Zip" => $rsOrder->fields["oxdelzip"],
                "City" => $rsOrder->fields["oxdelcity"],
                "Country" => $rsOrder->fields["oxdelcountry"],
                "Phone" => $rsOrder->fields["oxdelfon"],
                "Fax" => $rsOrder->fields["oxdelfax"],
                "Email" => ""
                )
            );
        
        $sSql = "SELECT oxgroups.oxid, oxtitle "
              . "FROM oxobject2group "
              . "LEFT JOIN oxgroups ON (oxgroups.oxid = oxobject2group.oxgroupsid) "
              . "WHERE oxobject2group.oxobjectid = ?";

        $rsGroups = Sql_Execute($db, $sSql, array($rsOrder->fields["oxuserid"]));
        $mainGroup = null;
        $xml["Order"]["AdditionalCustomerGroups"] = array();
        
        while(!$rsGroups->EOF)
        {
            $group = array( 
                "CustomerGroup" => array(
                    "CustomerGroupKey" => $rsGroups->fields["oxid"],
                    "CustomerGroupName" => $rsGroups->fields["oxtitle"]
                    )
                );
            
            if($mainGroup == null)
                $mainGroup = $group;
            else if($rsGroups->fields["oxid"] == "oxiddealer")
            {
                $xml["Order"]["AdditionalCustomerGroups"][] = $mainGroup;
                $mainGroup = $group;
            }
            else
                $xml["Order"]["AdditionalCustomerGroups"][] = $group;
            
            $rsGroups->MoveNext();
        }
        
        if($mainGroup == null)
            $mainGroup = array( "CustomerGroupKey" => "", "CustomerGroupName" => "");
        
        $xml["Order"] = array_merge($xml["Order"],$mainGroup["CustomerGroup"]);
        
        $aBankData = array();
        if($rsOrder->fields["oxpaymenttype"] == "oxiddebitnote" && $rsOrder->fields["oxpaymentdata"] != null)
        {
            $aBankData = oxUtils::getInstance()->assignValuesFromText($rsOrder->fields["oxpaymentdata"]);
            $aBankData = Oxid_StdClassNameValueArrayToHashtable($aBankData);
        }
        
        // Hinzugef�gt am 28.11.2013 von CM: Paypal
        $xml["Order"]["Payment"]["TransactionID"] = $rsOrder->fields["oxtransid"];
        $xml["Order"]["Payment"]["PaymentMethod"] = $rsOrder->fields["oxpaymenttype"];
        
        $xml["Order"]["Payment"]["Bank"] = array(
            "BankName" => $aBankData["lsbankname"],
            (is_numeric($aBankData["lsblz"]) ? "BankCodeNr" : "BIC") => $aBankData["lsblz"],
            (is_numeric($aBankData["lsktonr"]) ? "BankAccountNr" : "IBAN") => $aBankData["lsktonr"],
            "BankAccountOwner" => $aBankData["lsktoinhaber"],
            );
        
        $aCCData = array();
        if($rsOrder->fields["oxpaymenttype"] == "oxidcreditcard" && $rsOrder->fields["oxpaymentdata"] != null)
        {
            $aCCData = oxUtils::getInstance()->assignValuesFromText($rsOrder->fields["oxpaymentdata"]);
            $aCCData = Oxid_StdClassNameValueArrayToHashtable($aKkData);
        }

        $xml["Order"]["Payment"]["CreditCard"] = array(
           "CreditCardType" => $aCCData["kktype"],
           "CreditCardNr" => $aCCData["kknumber"],
           "CreditCardCheckNr" => $aCCData["kkpruef"],
           "CreditCardHolder" => $aCCData["kkname"]
            );
                
        $xml["Order"]["Shipping"] = array(
            "ShippingMethod" => $rsOrder->fields["oxdeltype"],
            "ShippingCost" => $rsOrder->fields["oxdelcost"],
            "ShippingVatPercent" => $rsOrder->fields["oxdelvat"]
            );

        $sSql = "SELECT oxorderarticles.oxid, oxorderarticles.oxartnum, oxamount, oxorderarticles.oxtitle, oxbrutprice, oxorderarticles.oxvat, oxselvariant "
              .", oxparent.oxvarname, oxarticles.oxean "
              ."FROM oxorderarticles "
              ."LEFT JOIN oxarticles AS oxarticles ON (oxorderarticles.oxartid = oxarticles.oxid) "
              ."LEFT JOIN oxarticles AS oxparent ON (oxarticles.oxparentid = oxparent.oxid) "
              ."WHERE oxorderid = ?";
        $rsProducts = Sql_Execute($db, $sSql, array($rsOrder->fields["oxid"]));
                
        while(!$rsProducts->EOF)
        {            
            $productXml = array(
                "Sku" => $rsProducts->fields["oxartnum"],
                "TransactionNr" => $rsProducts->fields["oxid"],
                "EAN" => $rsProducts->fields["oxean"],
                "Quantity" => $rsProducts->fields["oxamount"],
                "Title" => $rsProducts->fields["oxtitle"],
                "GrossPrice" => $rsProducts->fields["oxbrutprice"],
                "VatPercent" => $rsProducts->fields["oxvat"]
                );
                    
            if(!empty($rsProducts->fields["oxvarname"]))
            {
                $VariationDescr = "";
                
                //Multible varianten werden mit | dargestellt
                $vNames = explode(" | ", $rsProducts->fields["oxvarname"]);
                $vValues = explode(" | ", $rsProducts->fields["oxselvariant"]);

                for($i=0; $i<count($vNames); $i++)
                {
                    $name = $vNames[$i];
                    $value = $vValues[$i];

                    $productXml["Variations"][]["Variation"] = array(
                        "Name" => $type,
                        "Value" => $value
                        );
                    
                    if(!empty($VariationDescr))
                        $VariationDescr .= ", ";
                    $VariationDescr .= $name . ": " . $value;
                }
                
                $productXml["Variations"]["Description"] = $VariationDescr;
            }
            
            $xml["Order"]["Products"][] = array("Product" => $productXml);
            $rsProducts->MoveNext();
        }
        
        unset($rsProducts);
        
        $discount = 0;
        if(!empty($rsOrder->fields["oxdiscount"]))
             $discount += $rsOrder->fields["oxdiscount"];
        
        if(!empty($rsOrder->fields["oxvoucherdiscount"]))
             $discount += $rsOrder->fields["oxvoucherdiscount"]; 
        
        $xml["Order"]["Summary"] = array(
                  "DiscountAmount" => $discount,
                  "SubTotal" => $rsOrder->fields["oxtotalbrutsum"],
                  "Total" => $rsOrder->fields["oxtotalordersum"]
                );
        
        print_xml($xml,false,2);
        
        $rsOrder->MoveNext();
    }
    $schema = "\t</Orders>\n" .
              "</Data>\n";
    echo $schema;
}

function SendXMLHeader() {
    header("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT");  // immer geändert
    header("Cache-Control: no-cache, must-revalidate"); // HTTP/1.1
    header("Pragma: no-cache"); // HTTP/1.0
    header("Content-type: text/xml");
}

//--------------------------------------------------------------


function SendHTMLHeader() {
    header("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT");  // immer geändert
    header("Cache-Control: no-cache, must-revalidate"); // HTTP/1.1
    header("Pragma: no-cache"); // HTTP/1.0
    header("Content-type: text/html");
}

//--------------------------------------------------------------

function ShowHTMLMenu() {
    global $sVersionNr, $sVersionDatum, $sUser, $sPassword, $PHP_SELF;

    SendHTMLHeader();

    $Url = $PHP_SELF . "?user=" . $sUser . "&password=" . $sPassword;
?>
    <html><head></head><body>
            <h3>Oxid Shopanbindung</h3>
            <h4>Version <?php echo $sVersionNr; ?> Stand : <?php echo $sVersionDatum; ?></h4>
            <br><b>m&ouml;gliche Funktionen :</b><br><br>
            <a href="<?php echo $Url; ?>&action=version">Ausgabe XML Scriptversion</a><br>
            <?/*<br>*/?>
            <?/*<a href="<?php echo $Url; ?>&action=manufacturers_export">Ausgabe XML Manufacturers</a><br>*/?>
            <a href="<?php echo $Url; ?>&action=categories_export">Ausgabe XML Categories</a><br>
            <a href="<?php echo $Url; ?>&action=products_export">Ausgabe XML Products</a><br>
            <?/*<a href="<?php echo $Url; ?>&action=customers_export">Ausgabe XML Customers</a><br>*/?>
            <?/*<a href="<?php echo $Url; ?>&action=customers_newsletter_export">Ausgabe XML Customers-Newsletter</a><br>*/?>
            <?/*<br>*/?>
            <a href="<?php echo $Url; ?>&action=orders_export">Ausgabe XML Orders</a><br>
            <?/*<br>*/?>
            <?/*<a href="<?php echo $Url; ?>&action=config_export">Ausgabe XML Shop-Config</a><br>*/?>
            <br><b>Achtung: Die Verwendung der Skripte erfolgt auf eigene Gefahr. Es wird keinerlei Garantie &uuml;bernommen. Beachten Sie die beigef&uuml;gten Lizenztexte.</b>
        </body>
    </html>
<?php
}

function ProductsImageUpload() {
    global $action;
    
    //Das Bild wird zwischengespeichert, die eigentliche Import in Oxid kommt beim Anlegen des Artikels
    $sTmpPath = Oxid_GetImageTempPath($_FILES["products_image"]["name"]);
    $bMoveOk = move_uploaded_file($_FILES["products_image"]["tmp_name"],$sTmpPath);
    
    if($bMoveOk)
        print_xml_status(0, $action, "", "","FILE_NAME", basename($sTmpPath));
    else
        print_xml_status(-1, $action, "Das Bild konnte nicht abgespeichert werden");
}

function ProductsUpdate() {
    global $config, $action, $DefaultStockFlag, $ShopStartPageActionTitle, $DefaultShopId;
    
    $db = Oxid_GetDb();
    
    $data = array();    
    
    //Lagerhaltungsnummer muss immer vorhanden sein
    if(empty($_POST["products_model"]))
    {
        print_xml_status(-1, $action, "PARAMETER ERROR: Keine Lagerhaltungsnummer vorhanden");
        return;
    }
    
    //Grunddaten übernehmen
    AddFromPOSTIfExists($data, array(
        "products_quantity" => "oxstock",
        "products_model" => "oxartnum",
        "products_image" => "oxpic1",
        "products_price" => "oxprice",
        "products_weight" => "oxweight",
        "products_status" => "oxactive",
        "products_ean" => "oxean",
        "products_tax_percent" => "oxvat",
        "products_vpe" => "oxunitquantity",
        "products_shippingtime" => "oxmindeltime",
        "products_shippingtime" => "oxmaxdeltime",
        "products_sort" => "oxsort",
        "products_weight" => "oxweight",
        "products_width" => "oxwidth",
        "products_height" => "oxheight",
        "products_length" => "oxlength"
        ));
    
    if(isset($_POST["products_shippingtime"]))
        $data["oxdeltimeunit"] = "DAY";
    
    if(isset($_POST["products_me"]))
        $data["oxunitname"] = Oxid_MapVpeUnit($_POST["products_me"]);
    
    ////////////
    // Hersteller
    ///////////
    if(isset($_POST["manufacturers_name"]))
    {
        if(!empty($_POST["manufacturers_name"]))
        {
            //Hersteller nach namen suchen
            $iManufacturersId = Sql_GetOne($db, "SELECT oxid FROM oxmanufacturers WHERE oxtitle = ? AND oxshopid = ?", array($_POST["manufacturers_name"], $DefaultShopId));
            if($iManufacturersId == null)
            {
                //Hersteller wird neu angelegt
                
                $mData["oxid"] = oxUtilsObject::getInstance()->generateUID();
                $mData["oxactive"] = 1;
                $mData["oxshopid"] = $DefaultShopId;
                $mData["oxtitle"] = $_POST["manufacturers_name"];
                
                Sql_AutoExecute($db,"oxmanufacturers",$mData,"INSERT");
            }
            
            $data["oxmanufacturerid"] = $iManufacturersId;
        }
        else
            //Wenn ein leerer Herstellername
            $data["oxmanufacturerid"] = "";
        
    }

    ////////////
    // Texte
    ///////////
    Oxid_MapLangValue($data, "products_name", "oxtitle");
    Oxid_MapLangValue($data, "products_short_description", "oxshortdesc", true);
    
    ////////////
    // Bilder
    ///////////
    if (isset($_POST['products_image']))
        LinkImageToProduct($data, $_POST['products_image'], 1);
    if (isset($_POST['products_image_med']))
        LinkImageToProduct($data, $_POST['products_image_med'], 2);
    if (isset($_POST['products_image_large']))
        LinkImageToProduct($data, $_POST['products_image_large'], 3);

    for ($i = 3; isset($_POST['products_image_additional'][$i]) && $i < 12; $i++)
        LinkImageToProduct($data, $_POST['products_image_additional'][$i], $i+1);
    
    ////////////
    // Url
    ///////////
    if(isset($_POST["products_url"]))
    {
        $products_url = "";
        foreach($_POST["products_url"] as $sLangId => $url)
        {
            //Deutsche Produkt-Url bevorzugen
            if(trim($url) != "" || $sLangId == 0)
                $products_url = $url;
        }

        // Hinzugefügt am 15.11.2011 von CM: In products_url darf kein führendes http:// sein
        if(trim($products_url) != "")
        {
            $products_url = preg_replace("/^http\:\/\//","",$products_url);
            $data["oxexturl"] = $products_url;
        }
    }
    
    ////////////
    // Aktionspreis
    ///////////
    // Der Oxid-Shop unterstützt keinen Sonderpreis in dem Sinne
    // -> Wird der UVP angegeben wird dieser als durchgestrichener Preis angezeigt
    // -> Über die Funktion "Preis zur festgelegten Zeit aktualisieren, kann dann der Preis wider zurück gesetzt werden
    
    //Wenn ein Aktionspreis übergeben wird ist UVP = eigentliche Artikelpreis, Preis = Aktionspreis, Preis zum Aktualisieren = eigentliche Artikelpreis
    if(isset($_POST['specials_price']) && isset($_POST['specials_price_from']) && isset($_POST['specials_price_to']))
    {
        $dtNow = new DateTime();
        $dtSpecialsPriceFrom = new DateTime($special_price_from);
         
        if($_POST['specials_price'] > 0 && $dtSpecialsPriceFrom <= $dtNow)
        {
            AddFromPOSTIfExists($data, array(
                "products_price" => "oxtprice",
                "specials_price" => "oxprice",
                "specials_price_to" => "oxupdatepricetime",
                "prducts_price" => "oxupdateprice"
                ));
        }
    }
    
    ////////////
    // Varianten
    ///////////
    if(!empty($_POST["products_master_model"]) && isset($_POST["products_attributes_values"]))
    {
        //Varianten-Artikel
        
        $rsParent = Sql_Execute($db, "SELECT oxid FROM oxarticles WHERE oxartnum = ? AND oxshopid = ?",array($_POST["products_master_model"], $DefaultShopId));
        if($rsParent->RecordCount() <= 0)
        {
            print_xml_status(-1, $action, "Hauptartikel für Variante '" . $_POST["products_model"] . "' nicht gefunden.");
            return;
        }
        
        if($rsParent->RecordCount() > 1)
        {
            print_xml_status(-1, $action, "Es sind mehrere Hauptartikel mit der Lagerhaltungsnummer '" . $_POST["products_master_model"] . "' vorhanden.");
            return;
        }
            
        
        $data["oxvarselect"] = join(" | ",$_POST["products_attributes_values"]);
        $data["oxparentid"] = $rsParent->fields["oxid"];
        
        //Daten im Hauptartikel aktualisieren
        $sVariationNames = join(" | ", $_POST["products_attributes_keys"]);
        Sql_Execute($db, "UPDATE oxarticles SET oxvarstock = oxvarstock + ?, oxvarcount = oxvarcount + 1, oxvarname = ? WHERE oxid = ? AND oxshopid = ?",array($_POST["products_quantity"], $sVariationNames, $rsParent->fields["oxid"], $DefaultShopId));
    }
    
    //Artikel speichern
    //Ob der Artikel bereits existiert über die Lagerhaltungsnummer entscheiden
    $products_id = Sql_GetOne($db, "SELECT oxid FROM oxarticles WHERE oxartnum = ? AND oxshopid = ?",array($_POST["products_model"], $DefaultShopId));
    
    if(!empty($products_id))
    {
        Sql_AutoExecute($db,"oxarticles",$data,"UPDATE","oxid = '" . $products_id . "'");
        $mode = "UPDATE";
    }
    else
    {
        $products_id = $data["oxid"] = oxUtilsObject::getInstance()->generateUID();
        $data["oxsubclass"] = "oxarticle";
        $data["oxstockflag"] = $DefaultStockFlag;
        $data["oxshopid"] = $DefaultShopId;
        
        Sql_AutoExecute($db,"oxarticles",$data,"INSERT");
        $mode = "APPEND";
    }
    
    ////////////
    // lange Beschreibung
    ///////////
    //Bei einem hinzufügen einer neuen Sprache, wird die Datenbank verändert. Es kommen neue Spalten hinzu z.B. (oxtitle_3 für französisch, wenn französisch die id 3 hat)
    
    $data = array();

    Oxid_MapLangValue($data, "products_description", "oxlongdesc");
    
    if(count($data) > 0)
    {        
        $cnt = Sql_GetOne($db, "SELECT COUNT(*) FROM oxartextends WHERE oxid = ?",array($products_id));
        if(!empty($cnt))
            Sql_AutoExecute($db,"oxartextends",$data,"UPDATE","oxid = '" . $products_id . "'");
        else
        {
            $data["oxid"] = $products_id;
            Sql_AutoExecute($db,"oxartextends",$data,"INSERT");
        }
    }
    
    ////////////
    // Startseite
    ///////////
    if(isset($_POST["products_startpage"]))
    {
        $sStartPageActionId = Sql_GetOne($db, "SELECT oxid FROM oxactions WHERE oxtitle = ? AND oxshopid = ?",array($ShopStartPageActionTitle, $DefaultShopId));
        Sql_Execute($db, "DELETE FROM oxactions2article WHERE oxshopid = 'oxbaseshop' AND oxactionid = ? AND oxartid = ? AND oxshopid = ?",array($sStartPageActionId, $products_id, $DefaultShopId));
        
        if($_POST["products_startpage"] == "1")
        {
            $data = array();
            $data["oxshopid"] = $DefaultShopId;
            $data["oxactionid"] = $sStartPageActionId;
            $data["oxartid"] = $products_id;
            
            if(!empty($_POST["products_startpage_sort"]))
                $data["oxsort"] = $_POST["products_startpage_sort"];
            
            Sql_AutoExecute($db,"oxactions2article",$data,"INSERT");
        }
            
    }

    ////////////
    // Meta-Daten
    ///////////
    
    $aLanguages = $config->getConfigParam('aLanguageParams');
    foreach($aLanguages as $sLangCode => $aLangData)
    {
        $iLangId = $aLangData["baseId"];
        $data = array();
        
        if(!empty($_POST["products_meta_description"][$iLangId]))
            $data["oxdescription"] = $_POST["products_meta_description"][$iLangId];
        if(!empty($_POST["products_meta_keywords"][$iLangId]))
            $data["oxkeywords"] = $_POST["products_meta_keywords"][$iLangId];
        
        if(count($data) > 0)
        {
            $cnt = Sql_GetOne($db, "SELECT COUNT(*) FROM oxobject2seodata WHERE oxobjectid = ? AND oxlang = ? AND oxshopid = ?",array($products_id, $iLangId, $DefaultShopId));
            if(!empty($cnt))
                Sql_AutoExecute($db, "oxobject2seodata", $data, "UPDATE", " oxobjectid = " . $db->quote($products_id) . " AND oxlang = " . $db->quote($iLangId));
            else
            {
                $data["oxobjectid"] = $products_id;
                $data["oxlang"] = $iLangId;
                $data["oxshopid"] = $DefaultShopId;
                
                Sql_AutoExecute($db, "oxobject2seodata", $data, "INSERT");
            }
        }
        
    }
    
    print_xml_status(0, $_POST['action'], 'OK', $mode, 'PRODUCTS_ID', $products_id);
}

//--------------------------------------------------------------

function ProductsErase() {
    global $action, $DefaultShopId;

    if(!isset($_POST["products_model"]))
    {
        print_xml_status(-1, $action, "PARAMETER ERROR: Die Lagerhaltungsnummer wurde nicht übergeben");
        return;
    }
    
    $db = Oxid_GetDb();
    Sql_Execute($db, "DELETE FROM oxarticles WHERE oxartnum = ? AND oxshopid = ?",array($_POST["products_model"], $DefaultShopId));
    print_xml_status(0, $_POST['action'], 'OK');
}

function CategoriesUpdate() {
    global $action, $config, $DefaultShopId;
    
    $db = Oxid_GetDb();
    $data = array();
    
    //Ein Mapping der CategorieID ist nötig, da Auction Studio incrementelle Ids vergibt (1,2,3,4...) der oxid-Shop jedoch guids verwendet
    //Die guids sind Shop-Übergreifend eindeutig. Bei Auction Studio kann es sein dass die gleiche Kategorie zu zwei unterschiedlichen ShopIds hochgeladen werden
    // -> Die Ids von Auction Studio sind Shopübergreifend eindeutig machen
    
    $sCatId = Oxid_GetCategoryId($_POST['catid'], $DefaultShopId);
    $sParentId = $_POST["parentid"];
    
    if(empty($sParentId))
    {
        //Root-Kategorie
        // -> parentid = oxroot, oxrootid = eigene id
        
        $data["oxparentid"] = "oxrootid";
        $data["oxrootid"] = $sCatId;
        $data["oxleft"] = 1;
        $data["oxright"] = 2;
    }else
    {
        //Unter-Kategorie
        // -> parentid = übergebene ParentId, oxrootid = parent.oxrootid
        $sParentId = Oxid_GetCategoryId($sParentId, $DefaultShopId);
        $rsParent = Sql_Execute($db, "SELECT oxrootid, oxleft, oxright FROM oxcategories WHERE oxid = ? AND oxshopid = ?", array($sParentId, $DefaultShopId));
        $data["oxparentid"] = $sParentId;
        $data["oxrootid"] = $rsParent->fields["oxrootid"];
        $data["oxleft"] = $rsParent->fields["oxright"];
        $data["oxright"] = $data["oxleft"] + 1;
    }

    AddFromPOSTIfExists($data, array(
       "name" => "oxtitle",
       "descr" => "oxdesc",
       "sort" => "oxsort",
    ));
    
    $rs = Sql_Execute($db, "SELECT oxrootid FROM oxcategories WHERE oxid = ? AND oxshopid = ?", array($sCatId, $DefaultShopId));
    if(!$rs->EOF)
    {
        $sOldRootId = $rs->fields["oxrootid"];
        
        $mode = "UPDATE";
        Sql_AutoExecute($db,"oxcategories", $data, "UPDATE","oxid = " . $db->quote($sCatId));
        
        //Bei einer aktualisierung aus dem Nestet Set-Modell eintfernen
        // -> wird unten neu hinzu gefügt
        if(!empty($sParentId))
        {
            Sql_Execute($db, "UPDATE oxcategories SET oxleft = oxleft -2 WHERE oxleft > ? AND oxrootid = ? AND oxshopid = ?", array($data["oxleft"], $sOldRootId, $DefaultShopId));
            Sql_Execute($db, "UPDATE oxcategories SET oxright = oxright -2 WHERE oxright > ? AND oxrootid = ? AND oxshopid = ?", array($data["oxright"], $sOldRootId, $DefaultShopId));
        }
    }else
    {
        $mode = "INSERT";
        $data["oxactive"] = 1;
        $data["oxid"] = $sCatId;
        $data["oxshopid"] = $DefaultShopId;
        Sql_AutoExecute($db,"oxcategories", $data, "INSERT");
    }
    
        //oxleft und oxright von allen nachfolgenden ids aktualisieren
    if(!empty($sParentId))
    {
        Sql_Execute($db, "UPDATE oxcategories SET oxleft = oxleft + 2 WHERE oxleft >= ? AND oxrootid = ? AND oxid != ? AND oxshopid = ?",array($data["oxleft"], $data["oxrootid"], $sCatId, $DefaultShopId));
        Sql_Execute($db, "UPDATE oxcategories SET oxright = oxright + 2 WHERE oxright >= ? AND oxrootid = ? AND oxid != ? AND oxshopid = ?",array($data["oxleft"], $data["oxrootid"], $sCatId, $DefaultShopId));
    }
    
    print_xml_status(0, $action, 'OK', $mode);
}

function Prod2CatEraseAll() {
    global $action;
    $db = Oxid_GetDb();
    
    $ProdID = $_POST['prodid'];
    
    if(!empty($ProdID))
    {
        Sql_Execute($db, "DELETE FROM oxobject2category WHERE oxobjectid = ?", array($ProdID));
        print_xml_status(0, $action, "OK");
    }else
        print_xml_status(-1,$action, "ERROR: Produkt-ID ist leer");
}

function Prod2CatUpdate() {
    global $action, $DefaultShopId;
    $db = Oxid_GetDb();
    
    $ProdID = $_POST['prodid'];
    $CatID = Oxid_GetCategoryId($_POST['catid'], $DefaultShopId);
    
    $cnt = Sql_GetOne($db, "SELECT COUNT(*) FROM oxarticles WHERE oxid = ?", array($ProdID));
    if($cnt <= 0)
    {
        print_xml_status(-1, $action, "ERROR: Artikel '" . $ProdID . "' nicht gefunden'");
        return;
    }
    
    $cnt = Sql_GetOne($db, "SELECT COUNT(*) FROM oxcategories WHERE oxid = ?", array($CatID));
    if($cnt <= 0)
    {
        print_xml_status(-1, $action, "ERROR: Kategorie '" . $_POST['catid'] . "' nicht gefunden'");
    }
    
    $data = array();
    $data["oxid"] = oxUtilsObject::getInstance()->generateUID();
    $data["oxobjectid"] = $ProdID;
    $data["oxcatnid"] = $CatID;
    
    Sql_AutoExecute($db,"oxobject2category", $data, "INSERT");
    
    print_xml_status(0, $action, "OK");
}

function SetOrderStates() {
    global $action, $config;
    
    $db = Oxid_GetDb();

    //Post-Daten komplett auslesen
    $sXmlData = file_get_contents('php://input');
    $doc = new DOMDocument();
    $doc->loadXML($sXmlData);
    if($doc == FALSE)
    {
        print_xml_status(99, $action, "XML konnte nicht gelesen werden. Die Anfrage ist nicht gültig.");
        return;
    }

    $aOrderStates = $doc->getElementsByTagName("OrderState");

    $aResults = array();

    foreach($aOrderStates as $orderState)
    {
        //Daten einlesen -> xmlGetValueFromChildNode prüft auf korrektheit
        $sOrderNr = XmlGetValueFromChildNode($orderState, "OrderID", true);
        $sStateToApply = XmlGetValueFromChildNode($orderState, "State", true);

        //Testen ob die Bestellung existiert
        $sOrderID = Sql_GetOne($db, "SELECT oxid FROM oxorder WHERE oxordernr = ?",array($sOrderNr));
        if(empty($sOrderID))
        {
            $error = array();
            $error['CODE']='-1';
            $error['CORRELATION_ID'] = $sOrderNr;
            $error['MESSAGE']="Bestellung " . $sOrderNr . " existiert nicht.";
            $aResults[] = $error;
            continue;
        }

        //Datum in Datenbank-Konformes Format umwandeln
        $Date = XmlGetValueFromChildNode($orderState, "Date", true);
        $Date = strtotime($Date);
        $DbDate = date("Y-m-d H:i:s",$Date);
        
        //in die Bestellung eintragen
        if($sStateToApply == "Bezahlt")
            Sql_Execute($db, "UPDATE oxorder SET oxpaid = ? WHERE oxid = ?",array($DbDate, $sOrderID));
        else if($sStateToApply == "Versandt")
        {
            $sTrackingNr = XmlGetValueFromChildNode($orderState, "TrackingNr", true);
            Sql_Execute($db, "UPDATE oxorder SET oxsenddate = ?, oxtrackcode = ? WHERE oxid = ?",array($DbDate, $sTrackingNr, $sOrderID));
        }
        else if($sStateToApply == "Abgeschlossen")
            Sql_Execute($db, "UPDATE oxorder SET oxfolder = 'ORDERFOLDER_FINISHED' WHERE oxid = ?",array($sOrderID));
        else if($sStateToApply != "Abgeschlossen")
        {
            $error = array();
            $error['CODE']='-1';
            $error['CORRELATION_ID'] = $sOrderNr;
            $error['MESSAGE']="Der Bestellstatus " . $sStateToApply . " wird nicht unterstützt.";
            array_push($aResults, $error);  
            continue;
        }
    }

    $xml["STATUS"] = array(
        "STATUS_DATA" => array(
            "CODE" => 0,
            "ACTION" => $action,
            "MESSAGE" => "",
            "RESULTS" => $aResults
            )
        );
    
    print_xml($xml);
}

// Hinzugefügt am 28.02.2013 von CM: 
function ClearCache()
{
    $ExcludeFiles = array(".htaccess");
    $result = true;
    
    if(!RemoveFilesInFolder(realpath("../tmp/smarty") , $ExcludeFiles))
        $result = false;
    if(!RemoveFilesInFolder(realpath("../tmp"), $ExcludeFiles))
        $result = false;
    
    if($result)
        print_xml_status(0, $action, "OK");
    else
        print_xml_status(-1, $action, "FILEACCESS ERROR");
}

function XmlGetValueFromChildNode($parentNode, $childName, $AbortIfEmpty = false)
{
    $nodes = $parentNode->getElementsByTagName($childName);
    
    $action = $_POST['action'];
    if(empty($action))
        $action = $_GET['action'];

    if($nodes->length <= 0)
    {
        if($AbortIfEmpty)
        {
            print_xml_status(-1, $action, "UPLOAD FAILED: '" . $childName . "' konnte nicht gefunden werden.","","","");
            die();
        }else
            return "";
    }

    $value = $nodes->item(0)->nodeValue;

    if(empty($value) && $AbortIfEmpty)
    {
        print_xml_status(-1, $action, "UPLOAD FAILED: '" . $childName . "' enthält keinen gültigen Wert.","","","");
        die();
    }

    return $value;
}

function Oxid_StdClassNameValueArrayToHashtable($x_StdClassArray)
{
    $result = array();
    
    foreach($x_StdClassArray as $data)
        $result[$data->name] = $data->value;
    
    return $result;
}

function Oxid_GetDb()
{
    $db = oxDb::getDb(oxDb::FETCH_MODE_ASSOC);
    $db->Execute("SET NAMES utf8");
    return $db;
}

function Oxid_MapVpeUnit($x_Unit)
{
    $sUnit = strtolower($x_Unit);
    
    switch($sUnit)
    {
        case "g":
        case "gramm":
            return "_UNIT_G";
        case "kg":
        case "kilogramm":
            return "_UNIT_KG";
        case "l":
        case "liter":
            return "_UNIT_L";
        case "ml":
        case "millilieter":
            return "_UNIT_ML";
        case "cm":
        case "zentimeter":
            return "_UNIT_CM";
        case "mm":
        case "millimeter":
            return "_UNIT_MM";
        case "m":
        case "meter":
            return "_UNIT_M";
        case "m2":
        case "m²":
        case "qm":
        case "quadratmeter":
            return "_UNIT_M2";
        case "m3":
        case "m³":
        case "kbm":
        case "kubikmeter":
            return "_UNIT_M3";
        case "stück":
        case "stueck":
        case "":
            return "_UNIT_PIECE";
    }
    
    return $x_Unit;
}

function AddFromPOSTIfExists(&$x_Array, $x_KeyMapping)
{
    foreach($x_KeyMapping as $postKey => $arrayKey)
    {
        if(isset($_POST[$postKey]))
            $x_Array[$arrayKey] = $_POST[$postKey];
    }
}

function Oxid_MapLangValue(&$x_DbData, $x_Name, $x_ColumnName, $x_RemoveHtml = false)
{
    //Bei einem Hinzufügen einer neuen Sprache, wird die Datenbank erweitert. Es kommen neue Spalten hinzu z.B. (oxtitle_3 für französisch, wenn französisch die id 3 hat)
    
    foreach($_POST[$x_Name] as $iLangId => $oValue)
    {
        if(trim($oValue) != "")
        {
            $sColumnAppendix = "";
            if($iLangId > 0)
                $sColumnAppendix = "_" . $iLangId;
            
            if($x_RemoveHtml)
                $oValue = html_entity_decode(strip_tags ($oValue), ENT_COMPAT | ENT_HTML401, "UTF-8");
            
            $x_DbData[$x_ColumnName.$sColumnAppendix] = $oValue;
        }
    }
}

function Oxid_GetImageTempPath($ImageName)
{
    global $ImgTempNamePrefix;
    
    //Änderungen hier müssen auch in Oxid_GetImageRealName berücksichtigt werden
    $tempName = tempnam(getShopBasePath() . "/tmp", $ImgTempNamePrefix);
    unlink($tempName);
    return  $tempName . "_" . $ImageName;
}

function Oxid_GetImageRealName($x_ImageTempName)
{
    global $ImgTempNamePrefix;
    //Änderungen hier müssen auch in Oxid_GetImageTempPath berücksichtigt werden
    
    if(empty($x_ImageTempName))
        return "";
    
    $iTempPrefixLen = strlen($ImgTempNamePrefix);
    $iPosRealName = strpos($x_ImageTempName,"_",$iTempPrefixLen + 1) +1;
    $sRealName = substr($x_ImageTempName, $iPosRealName);

    return $sRealName;
}

function Oxid_GetCategoryId($x_CategoryId, $x_ShopId)
{
    return "AS_" . $x_ShopId . "_" . $x_CategoryId;
}

function Sql_Execute($db, $x_Sql,$x_Params = array())
{
    $db = Oxid_GetDb();
    $rs = $db->Execute($x_Sql, $x_Params);

    $error = $db->ErrorMsg();
    if(!empty($error))
    {
        print_xml_status("-1", $action, "Fehler bei der Datenbankabfrage: " . $error,"","SQL", $x_Sql);
        exit();
    }
    
    return $rs;
}

function Sql_GetOne($db, $x_Sql, $x_Params = array())
{
    $value = $db->GetOne($x_Sql, $x_Params);
    
    $error = $db->ErrorMsg();
    if(!empty($error))
    {
        print_xml_status("-1", $action, "Fehler bei der Datenbankabfrage: " . $error,"","SQL", $x_Sql);
        exit();
    }
    
    return $value;
}

function Sql_AutoExecute($db, $x_Table, $x_Data, $x_Cmd, $x_Where = "")
{
    global $action;
    
    if(count($x_Data) <= 0)
        return "";
    
    $aFields = "";
    $aValues = array();

    foreach($x_Data as $sField => $value)
    {
        $aFields[] = $sField;        
        $aValues[] = $value;
    }
    
    if($x_Cmd == "INSERT")
        $sql = "INSERT INTO " . $x_Table . " (" . join(", ",$aFields) . ") VALUES (?" . str_repeat(",?", count($x_Data)-1) . ")";
    else if($x_Cmd == "UPDATE")
    {        
        $sql = "UPDATE " . $x_Table . " SET " . join(" = ?,",$aFields) . " = ?";
        if(!empty($x_Where))
            $sql .= " WHERE " . $x_Where;
    }
    
    return Sql_Execute($db, $sql, $aValues);
}

function LinkImageToProduct(&$data, $name,$imgPos)
{
    
    //Die Bilder werden vom Oxid-Shop dynamisch generiert, wenn das erstemal der Artikel aufgerufen wird
    // -> oxpicsgenerated muss hierzu auf 0 stehen
    if(!empty($name))
    {
        $sTmpPicPath = getShopBasePath() . "/tmp/" . $name;
        $sRealPicName = Oxid_GetImageRealName($name);

        // Ge�ndert am 28.11.2013 von CM: Oxid 4.8.1
        if(column_exists("oxarticles", "oxpicsgenerated"))
            $data["oxpicsgenerated"] = 0;
        
        if(column_exists("oxarticles", "oxpic".$imgPos))
        {
            $data["oxpic".$imgPos] = $sRealPicName;
            if(file_exists($sTmpPicPath))
                rename($sTmpPicPath, getShopBasePath(). "out/pictures/master/product/" .$imgPos . "/" . $sRealPicName);
        }else
            unlink($sTmpPicPath);
    }
    else
    {
        // Ge�ndert am 28.11.2013 von CM: Oxid 4.8.1
        if(column_exists("oxarticles", "oxpicsgenerated"))
            $data["oxpicsgenerated"] = 0;
        
        $data["oxpic".$imgPos] = "";
    }
}

function RemoveFilesInFolder($Folder, $ExcludeFiles)
{
    if(empty($Folder) || !is_dir($Folder))
        return false;

    $result = true;
    $files = glob($Folder . "/*");

    foreach($files as $file)
    {
        if((!empty($ExcludeFiles) && in_array(basename($file), $ExcludeFiles)) || $file == "." || $file == "..")
            continue;
        
        if(is_dir($file))
            continue;

        if(!@unlink($file))
            $result = false;
    }
    
    return $result;
}

?>